package com.template.controller;


import com.template.api.SmartMeterControllerAPI;
import com.template.common.utils.paramUtils;
import com.template.model.pojo.SmartMeter;
import com.template.model.pojo.SmartMeter;
import com.template.model.result.CommonResult;
import com.template.model.result.PageUtils;
import com.template.services.SmartMeterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-12-04
 */
@RestController
public class SmartMeterController implements SmartMeterControllerAPI {

    @Autowired
    private SmartMeterService smartMeterService;

    /**
     * 新增水电表
     * @param smartApply 水电表数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult insertSmartMeter(SmartMeter smartApply, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartMeterService.insertSmartMeter(smartApply);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 更新水电表
     * @param sa 水电表数据
     * @param bindingResult
     * @return
     */
    @Override
    public CommonResult updateSmartMeterById(SmartMeter sa, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = smartMeterService.updateSmartMeter(sa);
        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 水电表分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageSmartMeters(int currentPage, int pageCount, String name) {
        PageUtils<SmartMeter> result = smartMeterService.queryPageSmartMeters(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }


    @Override
    public CommonResult deleteSmartMeterById(int id) {

        SmartMeter data = smartMeterService.getSmartById(id);

        if(data == null){
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = smartMeterService.deleteSmartMeterById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

